//C++ includes
#include <iostream>
#include <memory>
#include <string>

//wpilib includes
#include <IterativeRobot.h>
#include <LiveWindow/LiveWindow.h>
#include <SmartDashboard/SendableChooser.h>
#include <SmartDashboard/SmartDashboard.h>

//Team302 includes
#include <subsys/interfaces/IChassis.h>
#include <driverInputs/OI.h>
#include <teleopDrive/TeleopDrive.h>
#include <subsys/factories/ChassisFactory.h>

using namespace Team302;

class Robot: public frc::IterativeRobot {
public:
	void RobotInit() {
		//Default wpilib template smart dashboard code
		chooser.AddDefault(autoNameDefault, autoNameDefault);
		chooser.AddObject(autoNameCustom, autoNameCustom);
		frc::SmartDashboard::PutData("Auto Modes", &chooser);

		m_teleopDrive = new TeleopDrive();
	}

	void AutonomousInit() override {}
	void AutonomousPeriodic() {}
	void TeleopInit() {}

	void TeleopPeriodic() {
		m_teleopDrive->Drive();
		ChassisFactory::GetInstance()->GetIChassis()->PrintDebug();
	}

	void TestPeriodic() {
		lw->Run();
	}

private:
	frc::LiveWindow* lw = LiveWindow::GetInstance();
	frc::SendableChooser<std::string> chooser;
	const std::string autoNameDefault = "Default";
	const std::string autoNameCustom = "My Auto";
	std::string autoSelected;

	TeleopDrive* m_teleopDrive;
};

START_ROBOT_CLASS(Robot)
