/*
 * OI.cpp
 *
 *  Created on: Oct 16, 2017
 *      Author: jonah  WOOOOOOO!
 */

#include <driverInputs/OI.h>
#include <driverInputs/OIDriverArcade.h>
#include <utils/DragonMath.h>

namespace Team302 {

OI::OI(ControllerType driverControllerType, ControllerType copilotControllerType) :
		m_driver(nullptr),
		m_copilot(nullptr),
		m_driverControllerType(driverControllerType),
		m_copilotControllerType(copilotControllerType) {

	//Create desired IOIDrive
	switch(driverControllerType) {
	case CONTROLLER:
		m_driver = new OIDriverArcade();
		break;
	default:
		m_driver = new OIDriverArcade();
		break;
	}

	//Create desired IOICopilot
	switch(copilotControllerType) {
	case CONTROLLER:
		//TODO: initialize m_copilot as OICopilot or whatever it will be called
		break;
	default:
		//TODO: initialize m_copilot as OICopilot or whatever it will be called
		break;
	}
}

OI::OI() :
		m_driver(new OIDriverArcade()),
      		m_copilot(nullptr),
		m_driverControllerType(CONTROLLER),
		m_copilotControllerType(CONTROLLER)
{
}

OI* OI::m_instance = nullptr;
OI* OI::GetInstance() {
	if (OI::m_instance == nullptr) {
		OI::m_instance = new OI(); //Default
	}
	return OI::m_instance;
}

void OI::ChangeControllerConfig(ControllerType driverControllerType, ControllerType copilotControllerType) {
	//If the desired configuration does not match the current one, delete the current one and construct the desired one
	if (driverControllerType != m_driverControllerType && copilotControllerType != m_copilotControllerType) {
		if (m_instance != nullptr) { //TODO: if statement might not be needed (deleting null pointers might be safe)
			delete m_instance;
		}
		m_instance = new OI(driverControllerType, copilotControllerType);
	}
}

//All actions
double OI::GetRobotXMagnitude() {
	return m_driver->GetRobotXMagnitude();
}

double OI::GetRobotYMagnitude() {
	return m_driver->GetRobotYMagnitude();
}

double OI::GetRobotRotationMagnitude() {
	return m_driver->GetRobotRotationMagnitude();
}

Vector2 OI::GetRobotTargetHeading() {
	return m_driver->GetRobotTargetHeading();
}

OI::~OI() {
	delete m_driver;
	delete m_copilot;
}

} /* namespace Team302 */
