/*
 * OIDriverArcade.cpp
 *
 *  Created on: Oct 18, 2017
 *      Author: jonah
 */

#include <driverInputs/OIDriverArcade.h>
#include <driverInputs/DragonXbox.h>
#include <utils/DragonMath.h>
#include <XboxController.h>

namespace Team302 {

OIDriverArcade::OIDriverArcade() {
	//TODO: take in controller curve/scale as a parameter
	DragonXbox::AXIS_SENSITIVITY_CURVE defaultCurve = DragonXbox::AXIS_LINEAR;
	DragonXbox::GetDriver()->SetCurve(DragonXbox::X_AXIS_LEFT_JOYSTICK, defaultCurve);
	DragonXbox::GetDriver()->SetCurve(DragonXbox::Y_AXIS_LEFT_JOYSTICK, defaultCurve);
	DragonXbox::GetDriver()->SetCurve(DragonXbox::X_AXIS_RIGHT_JOYSTICK, defaultCurve);
	DragonXbox::GetDriver()->SetCurve(DragonXbox::Y_AXIS_RIGHT_JOYSTICK, defaultCurve);
}

OIDriverArcade::~OIDriverArcade() {
	//no clean-up needed cuz dragonxbox is a cool guy :)
}

double OIDriverArcade::GetRobotXMagnitude() const {
	return DragonXbox::GetDriver()->GetAxis( DragonXbox::X_AXIS_LEFT_JOYSTICK );
}

double OIDriverArcade::GetRobotYMagnitude() const {
	return DragonXbox::GetDriver()->GetAxis( DragonXbox::Y_AXIS_LEFT_JOYSTICK );
}

double OIDriverArcade::GetRobotRotationMagnitude() const {
	return DragonXbox::GetDriver()->GetAxis( DragonXbox::X_AXIS_RIGHT_JOYSTICK );
}

Vector2 OIDriverArcade::GetRobotTargetHeading() const {
	return DragonXbox::GetDriver()->GetVector(GenericHID::kLeftHand);
}




} /* namespace Team302 */
