/*
 * RegularChassis.h
 *
 *  Created on: Dec 20, 2017
 *      Author: jonah
 */

#ifndef SRC_SUBSYS_REGULAR_REGULARCHASSIS_H_
#define SRC_SUBSYS_REGULAR_REGULARCHASSIS_H_

#include <subsys/interfaces/IChassis.h>
#include <CANTalon.h>

namespace Team302 {

class RegularChassis: public IChassis {
public:
	//Units can be found in the IChassis interface (im lazy)

	//Getters
	double GetVelocity() const override;
	double GetXLocation() const override;
	double GetYLocation() const override;
	double GetHeading() const override;

	ChassisType GetChassisType() const override;

	//Setters
	void SetTargetLocation(double newTargetX, double newTargetY) override;
	void SetPathTravelVelocity(double newTravelVelocity) override;
	void SetTargetLocationMode(TargetLocationMode newTargetLocationMode)override;
	void SetPowerMagnitudes(double xPower, double yPower, double rotationPower)override;
	void SetLeftRightPower(double leftPower, double rightPower) override;
	void UpdateChassis() override;

	void PrintDebug() override;

	RegularChassis();
	virtual ~RegularChassis() = default;

private:
	CANTalon* m_frontLeftMotor;
	CANTalon* m_frontRightMotor;
	CANTalon* m_backLeftMotor;
	CANTalon* m_backRightMotor;

	TargetLocationMode m_targetLocationMode;
	MovementMode m_movementMode;

	double m_x;
	double m_y;
	double m_direction;

	double m_xTarget;
	double m_yTarget;
	double m_directionTarget;

	double m_pathTravelVelocityTarget;

};

} /* namespace Team302 */

#endif /* SRC_SUBSYS_REGULAR_REGULARCHASSIS_H_ */
